<?php
/*
Plugin Name: NextGEN Custom Fields
Description: This plugin allows users to add custom fields to images in NextGEN Gallery 
Version: 0.2
Author: Shaun Alberts
Author URI: mailto:shaunalberts@gmail.com
*/
/*  
Copyright 2009  Shaun Alberts  (email : shaunalberts@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


// stop direct call
if(preg_match("#".basename(__FILE__)."#", $_SERVER["PHP_SELF"])) {die("You are not allowed to call this page directly.");}

//{
	//install funcs{
		register_activation_hook(__FILE__, "nggcf_install");
		
		function nggcf_install() {
			global $wpdb;
			
			$table_name = $wpdb->prefix."nggcf_fields";
			if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
				$sql = "CREATE TABLE `".$table_name."` (
					id BIGINT(19) NOT NULL AUTO_INCREMENT,
					field_name TEXT NULL,
					field_type TEXT NULL,
					drop_options TEXT NULL,
					dateadded DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
					UNIQUE KEY id (id)
					);";
				
				require_once(ABSPATH."wp-admin/includes/upgrade.php");
				dbDelta($sql);
			}
			
			$table_name = $wpdb->prefix."nggcf_field_values";
			if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
				$sql = "CREATE TABLE `".$table_name."` (
					id BIGINT(19) NOT NULL AUTO_INCREMENT,
					pid bigint(19) DEFAULT '0' NOT NULL,
					fid bigint(19) DEFAULT '0' NOT NULL,
					field_value TEXT NULL,
					dateadded DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
					UNIQUE KEY id (id)
					);";
				
				require_once(ABSPATH."wp-admin/includes/upgrade.php");
				dbDelta($sql);
			}
		}
	//}
	
	//api stuff{
		define("NGGCF_FIELD_TYPE_INPUT", 1);
		define("NGGCF_FIELD_TYPE_TEXTAREA", 2);
		define("NGGCF_FIELD_TYPE_SELECT", 3);
		
		//save custom field values (checks if it needs to insert or update)
		function nggcf_save_pics($gid, $post) {
			global $wpdb;
			if ( is_array($post["nggcf_fields"]) ) {
				foreach ($post["nggcf_fields"] as $pid=>$fields) {
					foreach ((array)$fields as $fid=>$val) {
						if($row = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."nggcf_field_values WHERE fid = '$fid' AND pid = '$pid'")) {
							$wpdb->query( "UPDATE ".$wpdb->prefix."nggcf_field_values SET field_value = '".$wpdb->escape($val)."' WHERE id = ".$row->id);
						}else{
							if($wpdb->escape($val)) { //only if there is a value, add it to the db 
								$wpdb->query( "INSERT INTO ".$wpdb->prefix."nggcf_field_values (id, pid, fid, field_value, dateadded) VALUES (null, '$pid', '$fid', '".$wpdb->escape($val)."', '".date("Y-m-d H:i:s", time())."')");
							}
						}
					}
				}
			}
		}
		
		//api that saves new custom fields
		function nggcf_save_field($config) {
			global $wpdb;
			
			if($wpdb->escape($config["field_name"])) {
				if($wpdb->get_row("SELECT * FROM ".$wpdb->prefix."nggcf_fields WHERE field_name = '".$wpdb->escape($config["field_name"])."'")) {
					return "ERROR: Field name already exists";
				}
				if($config["field_type"] != NGGCF_FIELD_TYPE_SELECT) { //can only have drop opts if it is a drop down
					$config["drop_options"] = "";
				}
				$qry = "INSERT INTO ".$wpdb->prefix."nggcf_fields (`id`, `field_name`, `field_type`, `drop_options`) VALUES (null, '".$wpdb->escape($config["field_name"])."', '".$wpdb->escape($config["field_type"])."', '".$wpdb->escape($config["drop_options"])."')";
				if($wpdb->query($qry)) {
					return true;
				}else{
					return "ERROR: Failed to save field";
				}
			}else{
				return "ERROR: Bad field name";
			}
			
		}
		
		//api that deletes a column from the list, and removes all values saved for it
		function nggcf_delete_field($fid) {
			global $wpdb;
			if(is_numeric($fid)) {
				if($wpdb->query("DELETE FROM ".$wpdb->prefix."nggcf_field_values WHERE fid = ".$fid)) {
					if($wpdb->query("DELETE FROM ".$wpdb->prefix."nggcf_fields WHERE id = ".$fid)) {
						return true;
					}
				}
				return false;
			}else{
				return false;
			}
		}

		//get a list of all custom fields
		function nggcf_get_field_list() {
			global $wpdb;
			
			$fields = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."nggcf_fields");
			
			return $fields;
		}
	//}
	
	add_action("admin_menu", "nggcf_admin_menu");
	
	function nggcf_admin_menu() {
		add_menu_page("NextGEN Gallery Custom Fields", "NGG Custom Fields", 8, __FILE__, "nggcf_plugin_options");
		add_submenu_page(__FILE__, "Setup NextGEN Gallery Custom Fields", "Setup Fields", 8, __FILE__, "nggcf_plugin_options");
	}
	
	function nggcf_plugin_options() {
		$filepath = admin_url()."admin.php?page=".$_GET["page"];
		?>
		<div class="wrap">
		<h2><?php _e("Setup Custom Fields", "nggcustomfields"); ?></h2>
		
		<?php
		if($_POST) {
			if(($err = nggcf_save_field($_POST["conf"])) !== true) {
				?>
				<div class="nggcf-error">
				<h3 class="nggcf-error-h3">Error Saving Data</h3>
				The following error was returned when trying to save the custom field:<br />
				<?php echo $err; ?>
				</div>
				<?php
			}
		}
		if(is_numeric($_GET["delete"])) {
			if(!nggcf_delete_field($_GET["delete"])) {
				?>
				<div class="nggcf-error">
				<h3 class="nggcf-error-h3">Error Saving Data</h3>
				There was an error trying to delete the field and its data.  Please try again in a moment.
				<?php echo $err; ?>
				</div>
				<?php
			}
		}
		?>
		
		<?php
		$fields = nggcf_get_field_list();
		if($fields) {
			?>
			<h3><?php _e("Existing Fields", "nggcustomfields");?></h3>
			<table cellspacing="0" class="widefat fixed" id="table-existing">
				<thead>
					<tr>
						<th><?php _e("Field Name", "nggcustomfields");?></th>
						<th><?php _e("Field Type", "nggcustomfields");?></th>
						<th><?php _e("Actions", "nggcustomfields");?></th>
					</tr>
				</thead>
				<?php
				foreach ((array)$fields as $key=>$val) {
					?>
					<tr>
						<td><?php echo $val->field_name; ?></td>
						<td>
							<?php
							switch($val->field_type) {
							case NGGCF_FIELD_TYPE_INPUT : echo "Text Input"; break;
							case NGGCF_FIELD_TYPE_TEXTAREA : echo "Text Area"; break;
							case NGGCF_FIELD_TYPE_SELECT : echo "Drop Down"; break;
							}
							?>
						</td>
						<td>
							[ <a class="nggcf_del_field" href="<?php echo $filepath; ?>&delete=<?php echo $val->id; ?>">Delete Field</a> ]
						</td>
					</tr>
					<?php
				}
			?>
			</table>
			<?php
		}
		?>
		
		<br />
		<div id="poststuff">
			<form id="" method="POST" action="<?php echo $filepath; ?>" accept-charset="utf-8" >
				<div class="postbox">
					<h3><?php _e("Add New Field", "nggcustomfields") ;?></h3>
					<table class="form-table">
						<tr valign="top"> 
							<th><?php _e("Display Name", "nggcustomfields") ;?>:</th> 
							<td><input type="text" size="35" name="conf[field_name]" value="" /></td>
						</tr>
					
						<tr valign="top"> 
							<th><?php _e("Field Type", "nggcustomfields") ;?>:</th> 
							<td>
								<select id="field_type" name="conf[field_type]" onchange="toggleDropOps(this.value);">
								<option value="<?php echo NGGCF_FIELD_TYPE_INPUT; ?>">Text Input</option>
								<option value="<?php echo NGGCF_FIELD_TYPE_TEXTAREA; ?>">Text Area</option>
								<option value="<?php echo NGGCF_FIELD_TYPE_SELECT; ?>">Select Drop Down</option>
								</select>
							</td>
						</tr>
						
						<tr valign="top" id="drop_options"> 
							<th><?php _e("Drop Down Options (comma seperated list)", "nggcustomfields") ;?>:</th> 
							<td><textarea cols="33" name="conf[drop_options]"></textarea><br /><i>eg: Some Option, Another Option, Third Option</i></td>
						</tr>
					</table>
					
					<div class="submit">
						<input class="button-primary" type="submit" value="<?php _e("Create Field", "nggcustomfields") ;?>"/>
					</div>
				</div>
			</form>
		</div>
		
		</div>
		
		<script>
		jQuery(document).ready(function(){
				//hide drop opts boxes for fields not needing them
				if(document.getElementById("field_type").value != <?php echo NGGCF_FIELD_TYPE_SELECT; ?>) {
					document.getElementById("drop_options").style.display = "none";
				}
				
				//js confirm on the delete links
				jQuery("a.nggcf_del_field").each(function() {
						this.onclick = function() {
							if(confirm("Are you sure you want to permanently remove this field and all its saved values?")) {
								return true;
							}else{
								return false;
							}
						}
				});
		});
		
		function toggleDropOps(val) {
			if(val == <?php echo NGGCF_FIELD_TYPE_SELECT; ?>) {
				document.getElementById("drop_options").style.display = "";
			}else{
				document.getElementById("drop_options").style.display = "none";
			}
		}
		</script>
		<?php
	}
	
	add_action("ngg_manage_gallery_custom_column", "nggcf_admin_col", 10 ,2);
	add_filter("ngg_manage_gallery_columns", "nggcf_manage_cols");
	add_action("ngg_update_gallery", "nggcf_save_pics", 10, 2);
	add_filter("ngg_image_object", "nggcf_image_obj", 10, 2); // new in ngg 1.2.1
	
	//add the col to array of cols
	function nggcf_manage_cols($gallery_columns) {
		global $wpdb;
		$fields = $wpdb->get_results("SELECT field_name FROM ".$wpdb->prefix."nggcf_fields");
		
		foreach ((array)$fields as $key=>$val) {
			$gallery_columns[$val->field_name] = $val->field_name;
		}
		
		return $gallery_columns;
	}
	
	//the field for managing the images in a gallery
	function nggcf_admin_col($gallery_column_key, $pid) {
		global $wpdb;
		
		$custCol = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."nggcf_fields WHERE field_name = '$gallery_column_key'");
		$value = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."nggcf_field_values WHERE fid = '".$custCol->id."' AND pid = '$pid'");
		
		switch($custCol->field_type) {
		case NGGCF_FIELD_TYPE_INPUT :?>
			<input name="nggcf_fields[<?php echo $pid ?>][<?php echo $custCol->id ?>]" style="width:95%;" value="<?php echo $value->field_value; ?>" />
			<?php	break;
		case NGGCF_FIELD_TYPE_TEXTAREA :?>
			<textarea name="nggcf_fields[<?php echo $pid ?>][<?php echo $custCol->id ?>]" style="width:95%;"><?php echo $value->field_value; ?></textarea>
			<?php	break;
		case NGGCF_FIELD_TYPE_SELECT :
			$opts = explode(",", $custCol->drop_options);
			?>
			<select name="nggcf_fields[<?php echo $pid ?>][<?php echo $custCol->id ?>]">
			<option value=""></option>
			<?php
				foreach ((array)$opts as $key=>$val) {
					echo "<option value='".trim($val)."'".(trim($value->field_value) == trim($val) ? " selected" : "").">".trim($val)."</option>";
				}
			?>
			</select>
			<?php	break;
		}
		?>
		<?php
	}
	
	function nggcf_hold_field_values($pid) {
		global $wpdb, $nggcf_values;
		
		//only run the select once (store results in mem for access later if func called again with same pid)
		if(!$nggcf_values[$pid]) {
			$value = $wpdb->get_results("SELECT vals.*, cols.field_name, cols.id AS field_id, cols.field_type FROM ".$wpdb->prefix."nggcf_field_values AS vals LEFT JOIN ".$wpdb->prefix."nggcf_fields AS cols ON vals.fid = cols.id WHERE vals.pid = '".$wpdb->escape($pid)."'");
			$nggcf_values[$pid] = array();
			foreach ((array)$value as $key=>$val) {
				$nggcf_values[$pid][$val->field_name] = $val;
			}
		}
	}
	
	//returns a specific fields value for a specific image
	function nggcf_get_field($pid, $fname) {
		global $nggcf_values;
		nggcf_hold_field_values($pid);
		
		return $nggcf_values[$pid][$fname]->field_value;			
	}
	
	//new filter in ngg 1.2.1 allows us to add to the list of images (later to be passed to the templates), while its being created!  Thanks Alex
	function nggcf_image_obj($pictureObj, $pid) {
		global $nggcf_values;
		
		nggcf_hold_field_values($pid);
		
		$pictureObj->ngg_custom_fields = array();
		foreach ($nggcf_values[$pid] as $key=>$val) {
			$pictureObj->ngg_custom_fields[$key] = $val->field_value;
		}
		
		return $pictureObj;
	}
//}
?>